package tests;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import dataModel.Chef;
import dataModel.ChefDeCuisine;
import dataModel.Employee;
import dataModel.EmployeeFactory;
import dataModel.SousChef;


public class EmployeeTest {
	private EmployeeFactory employeeFactory;
	
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		//this runs once, before _all_ tests. Nothing todo here.
		//See CDTest for explanations
	}

	@Before
	public void setUp() throws Exception {
		employeeFactory = new EmployeeFactory();
	}

	@Test
	public final void testEmployeeFactoryNull() {
		assertNotNull("After setup, the employeeFactory is not null", employeeFactory);
	}
	
	@Test
	public final void testEmployeeRecords() {
		Employee chef = employeeFactory.createEmp("John", "", "Doe", "Chef");
		assertTrue(chef instanceof Chef);
		
		chef = employeeFactory.createEmp("John", "", "Doe", "SousChef");
		assertTrue(chef instanceof SousChef);
		
		chef = employeeFactory.createEmp("John", "", "Doe", "ChefDeCuisine");
		assertTrue(chef instanceof ChefDeCuisine);
		
		chef = employeeFactory.createEmp("John", "", "Doe", "WrongType");
		assertEquals(chef,null);
		
	}
}
